#include "geosim.h"
/*#include "gspriv.h"*/

typedef struct EditRec	{

	char *text;
	int maxtlen, maxtlines;
	int inspt;
	int lastline;
	int *linebreaks;
	
	FontSizeType fsize;
	char *windowname, *dragareaname;
	boolean (*keyfilter)(char *);
	void (*notification)();	
	} EditRec;
	
void SetCurrentEditRec(EditRec *);

EditRec *GetCurrentEditRec();

void UpdateEditRec(EditRec *);

void DrawEditRec(EditRec *); /* be careful calling from outside */

EditRec *NewEditRec(char *text, int maxtlen, int maxtlines, 
		FontSizeType fsize, char *windowname,
		char *dragareaname, boolean (*keyfilter)(char *), 
		void (*notification)(void) );

void DisposEditRec(EditRec *);

void SetEditRecText(EditRec *rec, char *tbuf, int maxlen);

boolean ProcessChar(char ch);

/* Some useful key filters: */
boolean numeric_filter(char *ch);
boolean boolean_filter(char *ch);
boolean alphabetic_filter(char *ch);
boolean alphanumeric_filter(char *ch);
boolean c_identifier_filter(char *ch);
